> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developers.awork.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developers.awork.com/_mcp/server.

# Applies an operation to selected projects.

POST https://api.awork.com/api/v1/projects/batch/{operation}
Content-Type: application/json

Applies the selected operation to each project and returns successful and failed results. Supported operations include changing status or type, linking workflows, updating clients, leads, dates, teams, and tags, and deleting projects.
The user must have `write` permission for all projects and related entities modified by the operation.

Reference: https://developers.awork.com/apiv1/projects/post-projects-batch-by-operation

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Path parameters

- `operation` (string, required) — Batch operation route key.

### Body (application/json)

This endpoint expects a ProjectBatchOperationForm.

- `projectIds` (list of string, required) — Project ids affected by the batch operation.
- `projectStatusId` (string, optional, nullable) — Target project status for `changeprojectstatus`.
- `projectTypeId` (string, optional, nullable) — Target project type for `changeprojecttype`.
- `workflowId` (string, optional, nullable) — Workflow to link for `linkworkflow`.
- `projectStatusMapping` (list of ProjectStatusMappingEntry, optional, nullable) — Project status mappings used when linking a workflow.
- `taskStatusMapping` (list of TaskStatusMappingEntry, optional, nullable) — Task status mappings used when linking a workflow.
- `keepCustomFields` (boolean, optional, nullable) — Whether custom fields should be kept when linking a workflow.
- `keepCustomAutomations` (boolean, optional, nullable) — Whether custom automations should be kept when linking a workflow.
- `companyId` (string, optional, nullable) — Company to assign for `setclient`.
- `responsibleUserId` (string, optional, nullable) — Responsible user to assign for `setprojectlead`.
- `teamIds` (list of string, optional, nullable) — Team ids to add or remove for team batch operations.
- `newStartDate` (string, optional, nullable) — New start date for `setdates`.
- `newDueDate` (string, optional, nullable) — New due date for `setdates`.
- `removeStartDate` (boolean, optional, nullable) — Whether the start date should be removed for `setdates`.
- `removeDueDate` (boolean, optional, nullable) — Whether the due date should be removed for `setdates`.
- `daysOffset` (double, optional, nullable) — Day offset for `adjustdates`.
- `tags` (list of TagForm, optional, nullable) — Tags to add for `addtags`.
- `tagsToRemove` (list of DeleteTagForm, optional, nullable) — Tags to remove for `removetags`.
- `deleteTimeTrackings` (boolean, optional, nullable) — Whether related time trackings should be deleted for `delete`.

## Response

### 207

Multi-Status

- `ok` (StatusResult, optional)
- `notFound` (StatusResult, optional)
- `unauthorized` (StatusResult, optional)
- `badRequest` (StatusResult, optional)

## Errors

### 400 Bad Request Error

Bad Request

- `code` (string, required) — The error code.
- `description` (string, required) — The description of the error.
- `link` (string, required) — The link to the API documentation page.
- `details` (list of string, optional, nullable) — A list of details describing the error.
- `validationErrors` (list of ValidationErrorResponse, optional, nullable) — If a validation error occurred, this contains the validation errors for each property.
- `traceId` (string, optional, nullable) — The request trace id for tracking the request.

### 401 Unauthorized Error

Unauthorized

- `code` (string, required) — The error code.
- `description` (string, required) — The description of the error.
- `link` (string, required) — The link to the API documentation page.
- `details` (list of string, optional, nullable) — A list of details describing the error.
- `validationErrors` (list of ValidationErrorResponse, optional, nullable) — If a validation error occurred, this contains the validation errors for each property.
- `traceId` (string, optional, nullable) — The request trace id for tracking the request.

## Types

### ProjectStatusMappingEntry

Maps an existing project status to a workflow project status.

- `oldProjectStatusId` (string, required) — The Id of the existing project status to replace.
- `newProjectStatusId` (string, required) — The Id of the workflow project status to use instead.

### TaskStatusMappingEntry

Maps an existing task status to a workflow task status.

- `oldTaskStatusId` (string, required) — The Id of the existing task status to replace.
- `newTaskStatusId` (string, required) — The Id of the workflow task status to use instead.

### TagForm

- `name` (string, required) — The name of the tag to delete.
- `color` (string, optional, nullable) — The color of the tag. Use one of 'red', 'coral', 'yellow', 'green', 'teal', 'arctic', 'blue', 'azure', 'purple', 'violet'.

### DeleteTagForm

- `name` (string, required) — The name of the tag to delete.

### StatusResult

- `ids` (list of string, optional, nullable)

### ValidationErrorResponse

The validation error response.

- `property` (string, optional, nullable) — The name of the property that failed validation.
- `message` (string, optional, nullable) — The reason why this property failed validation.

## Examples

**Request**

```json
{
  "projectIds": [
    "string"
  ]
}
```

**Response**

```json
{
  "ok": {
    "ids": [
      "string"
    ]
  },
  "notFound": {
    "ids": [
      "string"
    ]
  },
  "unauthorized": {
    "ids": [
      "string"
    ]
  },
  "badRequest": {
    "ids": [
      "string"
    ]
  }
}
```

**SDK Code**

```python
import requests

url = "https://api.awork.com/api/v1/projects/batch/operation"

payload = { "projectIds": ["string"] }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.awork.com/api/v1/projects/batch/operation';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"projectIds":["string"]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.awork.com/api/v1/projects/batch/operation"

	payload := strings.NewReader("{\n  \"projectIds\": [\n    \"string\"\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.awork.com/api/v1/projects/batch/operation")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"projectIds\": [\n    \"string\"\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.awork.com/api/v1/projects/batch/operation")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"projectIds\": [\n    \"string\"\n  ]\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.awork.com/api/v1/projects/batch/operation', [
  'body' => '{
  "projectIds": [
    "string"
  ]
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.awork.com/api/v1/projects/batch/operation");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"projectIds\": [\n    \"string\"\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["projectIds": ["string"]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.awork.com/api/v1/projects/batch/operation")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```